bsbChart3 proc
	LOCAL ThreadID:dword
	
	;Touching the stack frame 
	mov eax,ebp 
	.while eax>esp 
		dec eax
		mov byte ptr [eax],0 
	.endw 
	
	push esi
	push edi
	push edx
	
	mov rowIndex,0
	mov memout,0
	
	invoke crt_fopen,offset szFileName,ASTR("rb")
	.if eax!=0
		mov pFile,eax
		;Temporary memory1
		invoke HeapAlloc,hHeap,HEAP_ZERO_MEMORY,TEMPSIZE
		mov pMem1,eax
		;Temporary memory2
		invoke HeapAlloc,hHeap,HEAP_ZERO_MEMORY,TEMPSIZE
		mov pMem2,eax
		
		invoke CreateEvent,0,FALSE,FALSE,0
		mov hRead1Event,eax
		invoke CreateEvent,0,FALSE,TRUE,0
		mov hRead2Event,eax
		invoke CreateEvent,0,FALSE,FALSE,0
		mov hWrite1Event,eax
		invoke CreateEvent,0,FALSE,TRUE,0
		mov hWrite2Event,eax
		invoke CreateEvent,0,FALSE,FALSE,0
		mov hFinish1Event,eax
		invoke CreateEvent,0,FALSE,FALSE,0
		mov hFinish2Event,eax
			
		invoke CreateThread,0,0,offset Write1Thread,0,0,addr ThreadID
		invoke CloseHandle,eax
		
		invoke CreateThread,0,0,offset Write2Thread,0,0,addr ThreadID
		invoke CloseHandle,eax
		
		lea edi,hWriteEvents
		mov eax,hFinish1Event
		mov dword ptr [edi],eax
		mov eax,hFinish2Event
		mov dword ptr [edi+4],eax
		invoke WaitForMultipleObjects,2,offset hWriteEvents,TRUE,5000
		
		invoke HeapFree,hHeap,HEAP_NO_SERIALIZE,pMem1
		invoke HeapFree,hHeap,HEAP_NO_SERIALIZE,pMem2
		invoke crt_fclose,pFile

		invoke MoveWindow,hCHART,0,0,imageW,imageH,FALSE 
		invoke ShowWindow,hCHART,SW_SHOW
		invoke RedrawWindow,hCHART,0,0,RDW_INVALIDATE
	.endif
	
@Exit:
	pop edx
	pop edi
	pop esi
    
    ret
    
bsbChart3 endp

Write1Thread proc lParam:dword
		mov eax,bsbH
		cmp eax,rowIndex
		je @F ;All rows processed?
	
	invoke WaitForSingleObject,hRead2Event,INFINITE
	.if eax==0
		invoke Read,pMem1
		;save data for Write1 before next read will change them
		push readstart 
		push rowsread 
		push prevIndex
		pop prevIndex1
		pop rowsread1 
		pop readstart1
		invoke SetEvent,hRead1Event ;Read finished
	.endif
	
	invoke WaitForSingleObject,hWrite2Event,INFINITE
	.if eax==0
		invoke Write1,pMem1
		invoke SetEvent,hWrite1Event ;Write1 finished
	.endif
	
	jmp Write1Thread
	mov eax,bsbH
	cmp eax,rowIndex
	je @F ;All rows processed?
	
@@: invoke SetEvent,hFinish1Event
	ret

Write1Thread endp

Write2Thread proc lParam:dword
		mov eax,bsbH
		cmp eax,rowIndex
		je @F ;All rows processed?
	
	invoke WaitForSingleObject,hRead1Event,INFINITE
	.if eax==0
		invoke Read,pMem2
		;save data for Write2 before next read will change them
		push readstart
		push rowsread 
		push prevIndex
		pop prevIndex2
		pop rowsread2 
		pop readstart2
		invoke SetEvent,hRead2Event ;Read finised
	.endif
	
	invoke WaitForSingleObject,hWrite1Event,INFINITE
	.if eax==0
		invoke Write2,pMem2
		invoke SetEvent,hWrite2Event ;Write2 finished
	.endif
	mov eax,bsbH
	cmp eax,rowIndex
	je @F ;All rows processed?
	
	jmp Write2Thread
	
@@:	invoke SetEvent,hFinish2Event
	
	ret

Write2Thread endp

GetRowPixels proc pRowOffset:dword,row:dword,startrow:dword
	LOCAL col:dword
	LOCAL b:dword
	LOCAL pixel:dword
	LOCAL multiplier:dword
	LOCAL written:dword
	LOCAL bsbCol:dword
	
	;Touching the stack frame 
	mov eax,ebp 
	.while eax>esp 
		dec eax
		mov byte ptr [eax],0 
	.endw 
	
	push esi
	push edi
	push edx
	
	mov esi,pRowOffset
	
	mov col,0
	;Row numbers. First and eventually second bytes
	xor ecx,ecx
@@:	and ecx,7Fh
	shl ecx,7
	push ecx
	movzx eax,byte ptr [esi]
	inc esi					
	pop ecx
	add ecx,eax
	cmp eax,80h
	jae	@B
	
	;Check for end of row
	mov al,0
	mov ecx,bsbW
	repne scasb
	je @F
	;The row will not be processed
	mov eax,-1
	pop edx
	pop edi
	pop esi
	ret
	
	;Memory for bmp pixel values
@@:	mov edi,pPixelData
	mov eax,row
	add eax,startrow
	mov ecx,bsbW
	add ecx,padding
	mul ecx
	add edi,eax
			
@Scanrow:	
	movzx eax,byte ptr [esi] ;invoke crt_fgetc,stream
	inc esi
	mov b,eax
	
	or eax,eax
	je @EndOfRow
	
	mov ecx,7
	mov eax,ColorDepth
	sub ecx,eax
	
	;Retrieve pixel value
	mov eax,b
	and eax,7Fh
	shr eax,cl
	dec eax
	mov pixel,eax
	
	;Calculate how many times the same pixel value should be painted
	mov ecx,ColorDepth
	movzx ecx,byte ptr mul_mask[ecx]
	mov eax,b
	and eax,ecx
	.while b>=80h
		shl eax,7
		push eax
		movzx eax,byte ptr [esi]
		inc esi
		pop ecx
		mov b,eax
		and eax,7Fh
		add eax,ecx
	.endw
	inc eax
	.if eax>bsbW
		mov eax,bsbW
	.endif
	mov multiplier,eax
	
	;Start of storing pixel values
	xor ecx,ecx
	.while ecx<multiplier
		push ecx
		
		mov eax,col
		.if eax<bsbW
			mov ecx,pixel
			mov byte ptr [edi],cl
			inc edi
			inc written
			inc col
		.endif
		inc bsbCol
		
		pop ecx
		inc ecx
	.endw
	mov eax,col
	cmp eax,bsbW
	jle @Scanrow
	jmp @Skiprow
	
@EndOfRow:
	;If end of row less than image width
	mov eax,bsbW 
	.if col<eax
		sub eax,col
		.if eax<8
			xor ecx,ecx
			.while ecx<eax
				push ecx
				push eax
				
				.if ecx<bsbW
					mov ecx,pixel
					mov byte ptr [edi],cl
					inc edi
					inc written
					inc col
				.endif
				
				inc bsbCol
				pop eax
				pop ecx
				inc ecx
			.endw
		.endif
	.endif
	
@Skiprow:	
	xor ecx,ecx
	.while ecx<padding
		mov byte ptr [edi],0
		inc edi
		inc written
		
		inc ecx
	.endw
	
	mov eax,esi
	
	pop edx
	pop edi
	pop esi

	ret

GetRowPixels endp

GetBSBFullRows proc 
	;pRowIndex = pointer to variable holding number of rows read from file. Counted from top to bottom
	;TEMPSIZE = size of temporary memory to read to.
	;pMemout = pointer to variable holding memory size actually read
	LOCAL rowleft:dword
	LOCAL mem:dword
	
	;Touching the stack frame 
	mov eax,ebp 
	.while eax>esp 
		dec eax
		mov byte ptr [eax],0 
	.endw 
	
	push esi
	push edi
	push edx
	
	lea ecx,rowIndex
	mov ecx,dword ptr [ecx]
	push ecx ;store previous rowindex 0 -> (bsbH-1)
	
	;Check how many rows are left before reading
	mov eax,bsbH
	mov rowleft,eax
	sub rowleft,ecx
	.if rowleft==0
		mov eax,-1
		jmp @Exit
	.endif
	
	;Calculate current pointer to bsb row
	mov edi,pIndex
	pop eax ;restore previous rowindex
	mov ecx,4
	mul ecx 
	add edi,eax
	
	mov edx,dword ptr [edi]
	xor ecx,ecx
	xor eax,eax
	.while eax<TEMPSIZE
		mov mem,eax
		add edi,4
		mov eax,dword ptr [edi]
		sub eax,edx
		inc ecx
		.if ecx>rowleft
			jmp @F
		.endif
	.endw
@@:	dec ecx ;rows within memory size
	push ecx ;store number of read rows
	
	;Output memory size
	mov eax,mem
	lea edi,memout
	mov dword ptr [edi],eax
	
	pop eax ;Returnvalue = rows within memory size
	
@Exit:
	pop edx
	pop edi
	pop esi

	ret

GetBSBFullRows endp

Read proc pMem:dword
	
	push esi
	push edi
	push edx
	
	invoke GetBSBFullRows ;Return value = number of rows to read from disk
	.if eax!=-1
		mov rowsread,eax ;number of rows to read from disk -> memout
		
		;Read from file to temp memory
		mov edi,pIndex
		mov eax,rowIndex
		mov ecx,4
		mul ecx
		add edi,eax
		push edi 
		mov eax,dword ptr [edi]
		invoke crt_fseek,pFile,eax,SEEK_SET
		invoke crt_fread,pMem,memout,1,pFile
		
		pop readstart
		
		push rowIndex
		pop prevIndex
		mov eax,rowsread
		add rowIndex,eax
		
	.endif
	
	pop edx
	pop edi
	pop esi
	
	ret

Read endp

Write1 proc pMem:dword
	LOCAL row:dword
	
	;Touching the stack frame 
	mov eax,ebp 
	.while eax>esp 
		dec eax
		mov byte ptr [eax],0 
	.endw 
	
	push esi
	push edi
	push edx
	
	mov edi,readstart1
	mov edx,dword ptr [edi] ;Value of first row offset in jump table
	xor ecx,ecx
	.while ecx<rowsread1
		push ecx
		
		mov row,ecx
		push edx
		mov eax,dword ptr [edi] ;offset
		sub eax,edx
		mov esi,pMem
		add esi,eax ;New pointer to bsb row
		
		invoke GetRowPixels,esi,row,prevIndex1
		.if eax==-1
			add esp,8
			jmp @Exit
			;set event to read from alternative memory space
		.endif
		
		add edi,4
		pop edx
		
		pop ecx
		inc ecx
	.endw
	
@Exit:
	pop edx
	pop edi
	pop esi

	ret

Write1 endp

Write2 proc pMem:dword
	LOCAL row:dword
	
	;Touching the stack frame 
	mov eax,ebp 
	.while eax>esp 
		dec eax
		mov byte ptr [eax],0 
	.endw 
	
	push esi
	push edi
	push edx
	
	mov edi,readstart2
	mov edx,dword ptr [edi] ;Value of first row offset in jump table
	xor ecx,ecx
	.while ecx<rowsread2
		push ecx
		
		mov row,ecx
		push edx
		mov eax,dword ptr [edi] ;offset
		sub eax,edx
		mov esi,pMem
		add esi,eax ;New pointer to bsb row
		
		invoke GetRowPixels,esi,row,prevIndex2
		.if eax==-1
			add esp,8
			jmp @Exit
			;set event to read from alternative memory space
		.endif
		
		add edi,4
		pop edx
		
		pop ecx
		inc ecx
	.endw
	
@Exit:
	pop edx
	pop edi
	pop esi

	ret

Write2 endp




